#include <bits/stdc++.h>
#include <stdio.h>

#define REP(i, N) for(int (i)=0; (i) < (N); (i)++)
#define INF 90000000

using namespace std;
typedef long int ll;

// zapamatovane odpovedi [obchodnik][podmnozina darku][zaplacena doprava?]
int dp[111][1<<16][2];

// ceny[i][0] je cena dopravy, ceny[i][1..m] ceny darku obchodnika i
int ceny[111][22];

int n,m;

int solve(int prodejce, int darky, bool zaplaceno) {
	// uz jsme vlezli na prodejce, co neexistuje
	if(prodejce == n) {
		// mame vse nakoupeno -> uz neni treba nic dalsiho platit
		if(darky == (1<<m)-1) {
			return 0;
		}

		// jinak tento stav neodpovida korektnimu reseni
		return INF;
	}

	int& ans = dp[prodejce][darky][zaplaceno];

	if(ans == -1) {
		// reseni ve kterem ignorujeme aktualniho prodejce
		ans = solve(prodejce+1, darky, 0);

		// pokud od aktualniho prodejce vezmeme nejaky darek, kolik zaplatime za dopravu?
		// pokud uz jsme dopravu platili, tak nic, jinak cenu dopravy
		int doprava = zaplaceno ? 0 : ceny[prodejce][0];

		for(int d = 0; d < m; d++) {
			if((darky&(1<<d)) == 0) {
				// darek cislo p jeste nemame, zkusime ho vzit u aktualniho prodejce
				int cena = doprava+ceny[prodejce][d+1];

				// kolik nejmene nas bude stat nakoupeni zbylych darku?
				int zbytek = solve(prodejce, darky|(1<<d), 1);

				ans = min(ans, cena+zbytek);
			}
		}
	}

	return ans;
}

int main() {
	memset(dp, -1, sizeof(dp));
	scanf("%d%d", &n, &m);
	REP(i, n) REP(j, m+1) scanf("%d", &ceny[i][j]);

	printf("%d\n", solve(0, 0, 0));

	return 0;
}
